
"use client";

import React, { useState, useEffect } from "react";
import {Text,Button,TextInput,PasswordInput,Title,Card,Group,Flex,Box,Image,Anchor,Stack} from "@mantine/core";
import { notifications } from "@mantine/notifications";
import myImage from '@/app/image/ebanking.jpg';
import frontPage from '@/app/image/ib_front_page.jpg';
import NextImage from "next/image";
import { Providers } from "@/app/providers";
import { useRouter } from "next/navigation";

function generateCaptcha(length = 6) {
    const chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    return Array.from({ length }, () => chars[Math.floor(Math.random() * chars.length)]).join("");
}

export default function Login() {
    const router = useRouter();
    const [error, setError] = useState<string | null>(null);
    const [CIF, SetCIF] = useState("");
    const [psw, SetPsw] = useState("");
    const [captcha, setCaptcha] = useState("");
    const [inputCaptcha, setInputCaptcha] = useState("");

    useEffect(() => {
        setCaptcha(generateCaptcha());
    }, []);

    const regenerateCaptcha = () => {
        setCaptcha(generateCaptcha());
        setInputCaptcha("");
    };

    async function handleLogin(e: React.FormEvent) {
        e.preventDefault();
        const onlyDigit = /^\d{11}$/;
        if (!onlyDigit.test(CIF)) {
            setError('Input value must be 11 digit');
        }

        if (inputCaptcha !== captcha) {
            notifications.show({
                withBorder: true,
                color: "red",
                title: "Captcha Error",
                message: "Please enter the correct captcha",
                autoClose: 5000,
            });
            return;
        }

        if (CIF === "30022497139" && psw === "SecurePass123!") {
            const token = "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiIxMjM0NTY3ODkwIiwibmFtZSI6IkpvaG4gRG9lIiwiYWRtaW4iOnRydWUsImlhdCI6MTUxNjIzOTAyMn0.KMUFsIDTnFmyG3nMiGM6H9FNFUROf3wh7SmqJp-QV30";
            localStorage.setItem("customerNumber", CIF);
            localStorage.setItem("password", psw);
            localStorage.setItem("access_token", token);
            router.push("/home");
        } else {
            // SetCIF('');
            // SetPsw('');
            // setCaptcha('');
            notifications.show({
                withBorder: true,
                color: "red",
                title: "Wrong User Id or Password",
                message: "Wrong User Id or Password",
                autoClose: 5000,
            });
        }
    }

    return (
        <Providers>
            <div style={{ backgroundColor: "#f8f9fa", width: "100%", height: "100vh", paddingTop: "5%" }}>
                <Box style={{ position: 'fixed', width: '100%', height: '12%', top: 0 }}>
                    <Image
                        // radius="md"
                        fit="cover"
                        src={myImage}
                        component={NextImage}
                        alt="ebanking"
                        style={{ width: "100%", height: "100%" }}
                    />
                </Box>
                <Box
                    style={{
                        width: "100%",
                        height: "10%",
                        overflow: "hidden",
                        whiteSpace: "nowrap",
                        padding: "8px 0",
                    }}
                >
                    <Text
                        component="span"
                        style={{
                            display: "inline-block",
                            paddingLeft: "100%",
                            animation: "scroll-left 60s linear infinite",
                            fontWeight: "bold",
                            color: "#004d99",
                        }}
                    >
                        ⚠️ Always login to our Net Banking site directly or through Banks website.
                        ⚠️ Do not disclose your UserId and Password to any third party and keep Your UserId and Password strictly confidential.
                        ⚠️ KCC Bank never asks for UserId,Passwords and Pins through email or  phone.
                        ⚠️ Be ware of Phishing mails with links to fake bank's websites asking for personal information are in circulation.
                        ⚠️ Please DO NOT Click on the links given in the emails asking for personal details like bank account number, userID and password.
                        ⚠️ If you had shard your UserId and Password through such mails or links, please change your Password immediately.
                        ⚠️ Inform the Bank/branch in which your account is maintained for resetting your password.
                    </Text>
                    <style>
                        {`
              @keyframes scroll-left {
                0% { transform: translateX(0%); }
                100% { transform: translateX(-100%); }
              }
            `}
                    </style>
                </Box>

                <div style={{ display: "flex", height: "70vh" }}>
                    <div style={{ flex: 1, backgroundColor: "#c1e0f0", display: "flex" }}>
                        <Image
                            fit="cover"
                            src={frontPage}
                            component={NextImage}
                            alt="ebanking"
                            style={{ width: "100%", height: "100%" }}
                        />
                    </div>

                    <div
                        style={{
                            flex: 1,
                            backgroundColor: "#c1e0f0",
                            display: "flex",
                            justifyContent: "center",
                            alignItems: "center",
                        }}
                    >
                        <Card
                            shadow="lg"
                            padding="xl"
                            radius="md"
                            style={{
                                maxWidth: 480,
                                height: 380,
                                marginTop: 0,
                                paddingTop: 5,
                                backgroundColor: "#f0f0f0",
                                borderRadius: "12px",
                                boxShadow: "0 2px 10px rgba(0,0,0,0.1)",
                                // border:"1px solid black"
                            }}
                        >
                            <Stack gap="xs">
                                <Title order={6} style={{ marginLeft: 10 }}>
                                    <Text fs="italic">Welcome To KCC Bank</Text>
                                    <Text fw={700} style={{ fontSize: "18px", color: "#000066" }}>Internet Banking</Text>
                                </Title>
                                <Box
                                    style={{
                                        width: 370,
                                        marginTop: 0,
                                        paddingTop: 5,
                                        padding: "10px",
                                        border: "1px solid #e0e0d1",
                                    }}
                                >
                                    <Flex justify="center" gap="md">
                                        <form onSubmit={handleLogin}>
                                            <TextInput
                                                size="xs"
                                                label="User ID"
                                                placeholder="Enter your CIF no"
                                                type="text"
                                                inputMode="numeric"
                                                value={CIF}
                                                onInput={(e) => {
                                                    const input = e.currentTarget.value.replace(/\D/g, "");
                                                    if (input.length <= 11) {
                                                        SetCIF(input);
                                                    }
                                                }}
                                                required
                                                error={error}
                                            />

                                            <PasswordInput
                                                label="Password"
                                                size="xs"
                                                placeholder="Enter your password"
                                                value={psw}
                                                onChange={(e) => SetPsw(e.currentTarget.value)}
                                                required
                                            />
                                            <Group >
                                                <Box
                                                    style={{
                                                        padding: "5px 5px",
                                                        backgroundColor: "#ffffff",
                                                        fontFamily: "'UnifrakturCook',cursive",
                                                        textDecoration: "line-through",
                                                        userSelect: "none",
                                                    }}
                                                >
                                                    {captcha}
                                                </Box>
                                                <Button variant="outline" size="xs" onClick={regenerateCaptcha}>
                                                    Refresh
                                                </Button>
                                            </Group>
                                            <TextInput
                                                label="Enter CAPTCHA"
                                                size="xs"
                                                placeholder="Enter above text"
                                                value={inputCaptcha}
                                                onChange={(e) => setInputCaptcha(e.currentTarget.value)}
                                                required
                                            />
                                            <Button type="submit" fullWidth variant="filled" mt="md">
                                                Login
                                            </Button>
                                        </form>
                                    </Flex>
                                </Box>
                            </Stack>
                        </Card>
                    </div>
                </div>
                <Box
                    component="footer"
                    style={{
                        width: "100%",
                        textAlign: "center",
                        padding: "10px 0",
                        position: "fixed",
                        bottom: 0,
                        left: 0,
                        zIndex: 1000,
                        fontSize: "14px",
                    }}
                >
                    <Text>
                        © 2025 KCC Bank. All rights reserved. |{" "}
                        <Anchor href="document/disclaimer.pdf" target="_blank" rel="noopener noreferrer">Disclaimer</Anchor> |{" "}
                        <Anchor href="document/privacy_policy.pdf" target="_blank" rel="noopener noreferrer">Privacy Policy</Anchor> |{" "}
                        <Anchor href="document/phishing.pdf" target="_blank" rel="noopener noreferrer">Phishing</Anchor> |{" "}
                        <Anchor href="document/security_tips.pdf" target="_blank" rel="noopener noreferrer">Security Tips</Anchor>
                    </Text>
                </Box>
            </div>
        </Providers>
    );
}
